// THIS CODE IS (C)1998 BY JASON WINNEBECK
// YOU MAY DISTRIBUTE THIS FREELY, BUT IT MUST BE UNMODIFIED AND YOU MAY NOT
// CLAIM IT AS YOUR OWN WORK

// This program includes class SHIP in which can be set to drive a
// sprite/ship across the screen in a "ship fashion."  When finished the
// ship will obey screen (and can be modified to obey other) limits, and
// keep it's momentium in a realistic manner.  There will be no fricion, but
// class SHIP may be modified to account for friction.

//main includes here
#include <math.h>
#include <jrnd.h>

//defines for unused parts of allegro
#define alleg_mouse_unused
//#define alleg_timer_unused
//#define alleg_keyboard_unused
#define alleg_joystick_unused
//#define alleg_gfx_driver_unused
//#define alleg_palette_unused
//#define alleg_graphics_unused
#define alleg_vidmem_unused
#define alleg_flic_unused
//#define alleg_sound_unused
#define alleg_file_unused
#define alleg_datafile_unused
#define alleg_math_unused
#define alleg_gui_unused

//allegro include
#include "allegro.h"

// program global constants
int SW = 320;
int SH = 200;
int extras = 0;
int compassist = 0;
const int shipw = 32;
const int shiph = 32;

const float a2rad = (PI / 180.0);

// program global variables

class particle {
  private:
    //bullet's position and speed
    float x, y;
    float angle; //in degrees (not 0-256)
    float speed; //in pixels per update
    int life; //how many updates the bullet will live
    int totlife; //original life to calc %life to get color
  calc() { //update bullet pos
    x = x + sin(angle * a2rad) * speed;
    y = y + -cos(angle * a2rad) * speed;
  }
  public:
    int isalive; //is the bullet active?
    particle() { //init vars
      x = 0.0;
      y = 0.0;
      angle = 0.0;
      speed = 0.0;
      isalive = 0;
    }
    makenew(float x2, float y2, float angle2, float speed2, int life2) {
      x = x2;
      y = y2;
      angle = angle2;
      speed = speed2;
      totlife = life2;
      life = life2;
      isalive = 1;
    }
    display() {
      if (isalive) { //if the bullet is alive
        putpixel(screen, (int)x, (int)y, 0);
        calc();
        putpixel(screen, (int)x, (int)y, int(life/(float)totlife * 255.0));
        life--;
        if (life <= 0) {
          isalive = 0;
          putpixel(screen, (int)x, (int)y, 0);
        }
      }
    }
};

const maxpart = 1999;

class ship {
  private:
    //ship position, speed, and angle
    float x, y; //upper left corner of 32x32 ship
    float pangle, pangle360; //angle ship is facing 256/360-up 128/180-down
    float tangle360, tspeed;  //travelling speed/angle
    float turnspeed; //current turning speed

    //ship's capabilities
    float maxspeed, maxturn, turnaccel, maxaccel, maxdeccel;

    //ship's bullet & thrusts
    particle shipbullet[maxpart+1];
    float bulletspeed;
    char bslow; //this var keeps the particles and bullets from comming out
                // at like 1,000,000 a second
    int life;

    //graphics and sound
    BITMAP *shipsp; // ship pic
    PALETTE pal; //ship palette
    SAMPLE *takeoff; //ship start
    SAMPLE *gun; //gun sound
    int pan; //uses stereo to sound-position ship based on x,y

  calc() { //calc new position and check world limits
    x = x + sin(tangle360 * a2rad) * tspeed;
    y = y + -cos(tangle360 * a2rad) * tspeed;

    //calc new angle
    if (extras == 2) {
      pangle += turnspeed;
      pangle360 = pangle * 360.0 / 256.0;
    }

    //calc pan based on x
    pan = 255 * x / SW;

    //check limits
    if (x < 0.0) x = 0.0;
    if (y < 0.0) y = 0.0;
    if (x > SW-1-shipw) x = SW-1-shipw;
    if (y > SH-1-shiph) y = SH-1-shiph;
  }
  public:
    ship() { //loads ship bitmap and inits vars
      x = SW / 2;
      y = SH / 2;
      tangle360 = 360.0;
      tspeed = 0.0;
      pangle = 256.0;
      pangle360 = pangle * 360.0 / 256.0;
      maxspeed = 1.0;
      maxaccel = 1.0;
      maxdeccel = 1.0;
      maxturn = 1.0;
      turnspeed = 0.0;
      turnaccel = 0.0;
      bulletspeed = 20.0;
      shipsp = load_bmp("ship\\ship.bmp", pal);
      set_palette(pal);
      takeoff = load_wav("ship\\boom.wav");
      gun = load_wav("ship\\gun.wav");
    }
    ~ship() { //destructor destroys ship bitmap and sfx
      destroy_bitmap(shipsp);
      destroy_sample(takeoff);
      destroy_sample(gun);
    }
    //set ship attribs
    setattribship(float mxspeed, float mxaccel, float mxdeccel, float mxturn, float turnaccell) {
      maxspeed = mxspeed;
      maxaccel = mxaccel;
      maxdeccel = mxdeccel;
      maxturn = mxturn;
      turnaccel = turnaccell;
    }
    setattribbullet(float bulletspeed2, int life2) {
      bulletspeed = bulletspeed2;
      life = life2;
    }
    //throws out thrust particles (funky math makes it come out back)
    fart() {
      int c = 0;
      while (c < maxpart && shipbullet[c].isalive) {c++;}
      if (!shipbullet[c].isalive)
        shipbullet[c].makenew(x + shipw/2 + sin((pangle360 - 180.0) * a2rad) * shipw/2,
                              y + shiph/2 + -cos((pangle360 - 180.0) * a2rad) * shiph/2,
                              pangle360-(float)getrnd(200, 160), maxaccel, 30);
    }
    //throws out deccel particles
    backfart() {
      int c = 0;
      while (c < maxpart && shipbullet[c].isalive) {c++;}
      if (!shipbullet[c].isalive)
      if (compassist) {
        shipbullet[c].makenew(x + shipw/2 + sin(tangle360 * a2rad) * shipw/2,
                              y + shiph/2 + -cos(tangle360 * a2rad) * shiph/2,
                              tangle360+(float)getrnd(20, -20), maxdeccel, 30);
      } else {
        shipbullet[c].makenew(x + shipw/2 + sin(pangle360 * a2rad) * shipw/2,
                              y + shiph/2 + -cos(pangle360 * a2rad) * shiph/2,
                              pangle360+(float)getrnd(20, -20), maxdeccel, 30);
      }
    }
    //throws out turn particles
    rightfart() {
      int c = 0;
      while (c < maxpart && shipbullet[c].isalive) {c++;}
      if (!shipbullet[c].isalive)
        shipbullet[c].makenew(x + shipw/2 + sin((pangle360 + 15.0) * a2rad) * shipw/2,
                              y + shiph/2 + -cos((pangle360 + 15.0) * a2rad) * shiph/2,
                              pangle360+(float)getrnd(110, 70), turnaccel, 30);
    }
    leftfart() {
      int c = 0;
      while (c < maxpart && shipbullet[c].isalive) {c++;}
      if (!shipbullet[c].isalive)
        shipbullet[c].makenew(x + shipw/2 + sin((pangle360 - 15.0) * a2rad) * shipw/2,
                              y + shiph/2 + -cos((pangle360 - 15.0) * a2rad) * shiph/2,
                              pangle360+(float)getrnd(290, 250), turnaccel, 30);
    }
    //these functions change speed and direction and check bounds
    speedup() {
      if (tspeed <= maxaccel * 4) {
        play_sample(takeoff, 100, pan, 1500, 0);
        fart();
        fart();
        fart();
      }
      float alpha = (360.0-pangle360-(180.0-tangle360)) * a2rad;
      if (tspeed == 0) {
        tspeed = maxaccel;
        tangle360 = pangle360;
      } else {
        tspeed = sqrt(tspeed * tspeed + maxaccel * maxaccel - 2.0 * tspeed * maxaccel * cos(alpha));
        tangle360 = tangle360 + asin(maxaccel * sin(alpha) / tspeed) / a2rad;
      }
      fart();
      fart();
      fart();
      if (tspeed > maxspeed) tspeed = maxspeed;
    }
    slowdown() {  //slow the ship down
      if (tspeed > 0.0 || !compassist) {
        if (extras) {
          backfart();
          backfart();
          backfart();
        }
      }
      if (extras == 2 && compassist) {  //if rotational inertia
        if (turnspeed < 0.0) {
          turnspeed += turnaccel;
          leftfart();
          if (turnspeed > 0.0) turnspeed = 0.0;
        } else if(turnspeed > 0.0) {
          turnspeed -= turnaccel;
          rightfart();
          if (turnspeed < 0.0) turnspeed = 0.0;
        }
      }

      if (compassist) { //if rotating retro
        tspeed -= maxdeccel;
        if (tspeed < 0.0) tspeed = 0.0;
      } else {
        if (tspeed == 0) {
          tspeed = -maxaccel;
          tangle360 = pangle360 - 180.0;
        } else { //calc deccel vector
          float alpha = (360.0-(pangle360 + 180.0)-(180.0-tangle360)) * a2rad;
          tspeed = sqrt(tspeed * tspeed + maxdeccel * maxdeccel - 2.0 * tspeed * maxdeccel * cos(alpha));
          tangle360 = tangle360 + asin(maxdeccel * sin(alpha) / tspeed) / a2rad;
          if (tspeed > maxspeed) tspeed = maxspeed;
        }
      }
    }
    turnleft() {  //turn ship left
      if (extras) rightfart();
      if (compassist == 2) {
        slowdown();
        if (!key[KEY_UP]) speedup();
      }
      if (extras == 2) { //if rotational inertia increase rotational speed
        turnspeed -= turnaccel;
        if (turnspeed < -maxturn) turnspeed = -maxturn;
      } else { //if no rotational inertia
        pangle -= maxturn;
        pangle360 = pangle * 360.0 / 256.0;
      }
    }
    turnright() {
      if (extras) leftfart();
      if (compassist == 2) {
        slowdown();
        if (!key[KEY_UP]) speedup();
      }
      if (extras == 2) {
        turnspeed += turnaccel;
        if (turnspeed > maxturn) turnspeed = maxturn;
      } else {
        pangle += maxturn;
        pangle360 = pangle * 360.0 / 256.0;
      }
    }
    //shoot a bullet and make it come out the front (that's the funky math)
    shoot() {
      int c = 0;
      while (c < maxpart && shipbullet[c].isalive) {c++;}
      if (!shipbullet[c].isalive && !(bslow % 5)) {
        play_sample(gun, 255, pan, 1000, 0); //make gun sound
        shipbullet[c].makenew(x + shipw/2 + sin(pangle360 * a2rad) * shipw/2,
                              y + shiph/2 + -cos(pangle360 * a2rad) * shiph/2,
                              pangle360, bulletspeed, life);
      }
    }
    // do the drawing
    display() { //erases old position and updates new one
      bslow++;
      rectfill(screen, (int)x-1, (int)y-1, (int)x + shipw+1, (int)y + shiph+1, 0);
      calc();
      rotate_sprite(screen, shipsp, (int)x, (int)y, ftofix(pangle));
      for (int c=0; c<=maxpart; c++)
        shipbullet[c].display();
    }
};

volatile int fps = 0;

void fpsproc(...) {
  fps = 1;
}

END_OF_FUNCTION(fpsproc);

int main() {
//Declare unused drivers
  DECLARE_COLOR_DEPTH_LIST(
   COLOR_DEPTH_8
  );
  DECLARE_MIDI_DRIVER_LIST();
  randomize();

  set_config_file("ship\\ship.cfg");

  SW = get_config_int("ship", "screenwidth", 320);
  SH = get_config_int("ship", "screenheight", 200);

  //get extras
  extras = get_config_int("ship", "extras", 1);
  compassist = get_config_int("ship", "compassist", 0);

  allegro_init();
  install_keyboard();
  install_timer();
  install_sound(DIGI_AUTODETECT, MIDI_NONE, "");

  printf("This program is (C)1998 by Jason Winnebeck\n");
  printf("  You may freely distribute this program, but you may not\n");
  printf("modify it or claim it as your own work.\n");
  printf("Press a key. . .\n");
  readkey();

  set_gfx_mode(GFX_AUTODETECT, SW, SH, 0, 0);

  ship player;

  //setup ship
  player.setattribship(get_config_float("ship", "maxspeed", 15.0),
                       get_config_float("ship", "maxaccel", 1.0),
                       get_config_float("ship", "maxdeccel", 1.0),
                       get_config_float("ship", "maxturn", 5.0),
                       get_config_float("ship", "turnaccel", 1.0));
  player.setattribbullet(get_config_float("ship", "bulletspeed", 20.0),
                         get_config_float("ship", "life", 20.0));

  clear(screen);

  player.display();  //display initial position
  int c = 0;
  int mykey = 0;

  LOCK_VARIABLE(fps);
  LOCK_FUNCTION(fpsproc);

  install_int(fpsproc, 25);

  while (!key[KEY_ESC]) { //get input from player
    if (key[KEY_LEFT])
      player.turnleft();
    if (key[KEY_RIGHT])
      player.turnright();
    if (key[KEY_UP])
      player.speedup();
    if (key[KEY_DOWN])
      player.slowdown();
    if (key[KEY_SPACE])
      player.shoot();
    player.display();
    while (!fps) { } //wait for fps count
    fps = 0;
  }

  readkey();
  return 0;
}
